Bug 1803528 - Review Request: rstudio - Integrated development environment for the R programming language
Summary: Review Request: rstudio - Integrated development environment for the R progra...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-02-16 16:44 UTC by Iñaki Ucar
Modified: 2020-03-16 20:33 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-03-12 21:57:01 UTC
Type: ---
loganjerry: fedora-review+


Attachments (Terms of Use)

Description Iñaki Ucar 2020-02-16 16:44:34 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/iucar/rstudio/fedora-31-x86_64/01241167-rstudio/rstudio.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/iucar/rstudio/fedora-31-x86_64/01241167-rstudio/rstudio-1.2.5033-3.fc31.src.rpm

koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=41524024

Notes:
- Qt5, Boost, pandoc and MathJax successfully unbundled.
- Provides bundled(gin) and bundled(gwt).
- Base package contains all the common files for sub-packages rstudio-desktop and rstudio-server.
- rpmlint reports 'devel-file-in-non-devel-package /usr/libexec/rstudio/resources/templates/rcpp.cpp', but that's a template file.
- The scratch build fails for s390x due to a Java stack overflow. How can I find what's the default Java stack size for s390x and how to increase it?

Description:
RStudio is a set of integrated tools designed to help you be more productive with R. It includes a console, syntax-highlighting editor that supports direct code execution, as well as tools for plotting, history, debugging, and workspace management.

Fedora Account System Username: iucar

Comment 2 Jerry James 2020-02-20 02:52:11 UTC
Good job on fixing the s390x build!  I will take this review.

Comment 3 Jerry James 2020-02-20 05:11:50 UTC
These are the issues fedora-review found:

- If your application is a C or C++ application you must list a
  BuildRequires against gcc, gcc-c++ or clang.
  Note: No gcc, gcc-c++ or clang found in BuildRequires
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/C_and_C++/

- Package installs a %{name}.desktop using desktop-file-install or desktop-
  file-validate if there is such a file.

- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file LICENSE is not marked as %license
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/LicensingGuidelines/#_license_text

I think that last one is talking about these files:
- src/gwt/lib/gin/2.1.2/LICENSE
- src/cpp/session/resources/presentation/revealjs/LICENSE

Also, while the dictionaries may have come from Chromium, they are ultimately derived from hunspell.  We have many hunspell dictionaries in Fedora, and not just the English ones.  For the source of the bundled dictionaries in this package, see hunspell-en, hunspell-en-GB, and hunspell-en-US.  I'm not sure how this should be handled, but you must either unbundle these dictionaries or add "Provides: bundled(hunspell-en)", etc. to the spec file.

Speaking of bundling, this package bundles other software that we already have in Fedora.  This is what I have found so far:
- js-jquery: src/cpp/session/resources/grid/datatables/js/jquery.js
- rapidxml-devel: src/cpp/core/include/core/rapidxml
- texlive-synctex: src/cpp/core/tex/synctex
- zlib: src/cpp/core/zlib and src/cpp/core/include/core/zlib

I think we're going to have to go through the source tree carefully to see what else is bundled in it.

Comment 4 Iñaki Ucar 2020-02-20 10:58:05 UTC
(In reply to Jerry James from comment #3)
> These are the issues fedora-review found:
> 
> - If your application is a C or C++ application you must list a
>   BuildRequires against gcc, gcc-c++ or clang.
>   Note: No gcc, gcc-c++ or clang found in BuildRequires
>   See: https://docs.fedoraproject.org/en-US/packaging-guidelines/C_and_C++/

This conflicts with the "minimum requirements" guideline. RStudio requires R-devel, which in turn already requires gcc, gcc-c++ and others. That's why the guidelines for R packages state that only the R build-dependency is needed. This is not an R package though. And I don't have any special preference about this. What do you think?

> - Package installs a %{name}.desktop using desktop-file-install or desktop-
>   file-validate if there is such a file.

The file is automatically installed, so I need to run desktop-file-validate. Thanks.

> - If (and only if) the source package includes the text of the license(s)
>   in its own file, then that file, containing the text of the license(s)
>   for the package is included in %license.
>   Note: License file LICENSE is not marked as %license
>   See: https://docs.fedoraproject.org/en-US/packaging-
>   guidelines/LicensingGuidelines/#_license_text
> 
> I think that last one is talking about these files:
> - src/gwt/lib/gin/2.1.2/LICENSE
> - src/cpp/session/resources/presentation/revealjs/LICENSE

I missed those, thanks.

> Also, while the dictionaries may have come from Chromium, they are
> ultimately derived from hunspell.  We have many hunspell dictionaries in
> Fedora, and not just the English ones.  For the source of the bundled
> dictionaries in this package, see hunspell-en, hunspell-en-GB, and
> hunspell-en-US.  I'm not sure how this should be handled, but you must
> either unbundle these dictionaries or add "Provides: bundled(hunspell-en)",
> etc. to the spec file.

You're right. They provide the .aff and the .dic, but also some .dic_delta with additions. What if I symlink the first two and keep the delta? Not sure what happens if there are definitions in the delta that are already in the .dic (I suppose it may happen if there's a version mismatch).

> Speaking of bundling, this package bundles other software that we already
> have in Fedora.  This is what I have found so far:
> - js-jquery: src/cpp/session/resources/grid/datatables/js/jquery.js

And in fact, I've just discovered that we have xstatic-datatables-common, but the contents differ a little. The one bundled in RStudio is an older version. So I propose declaring bundled(js-datatables) (and thus I need to add MIT to the list of licenses) and substituting that version of jQuery with a symlink to the one provided by the system.

> - rapidxml-devel: src/cpp/core/include/core/rapidxml

This is just a header-only library, same version, and doesn't require any .so afterwards. I can substitute the file with a symlink. Is it worthwhile?

> - texlive-synctex: src/cpp/core/tex/synctex

Ok, I see that's in texlive-lib-devel. Another symlink.

> - zlib: src/cpp/core/zlib and src/cpp/core/include/core/zlib

I think we are fine here, because the one provided by the system should be picked. In fact, libz.so is listed in the automatic requires and no other libz.so is produced. So if I didn't miss anything, no change should be required.

> I think we're going to have to go through the source tree carefully to see
> what else is bundled in it.

Yeap, I'll take another closer look, especially to the "resources" directory.

Comment 5 Iñaki Ucar 2020-02-21 11:55:10 UTC
Spec URL: https://iucar.fedorapeople.org/pkgs/rstudio.spec
SRPM URL: https://iucar.fedorapeople.org/pkgs/rstudio-1.2.5033-5.fc31.src.rpm

koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=41733614

Here we go. I inspected carefully the source tree to unbundle some more things and declare others as bundled.

Declared as bundled:
- gwt-websockets, guice, aopalliance: Java add-ins for the gwt SDK.
- json-spirit, sundown: small C++/C libraries for JSON and Markdown parsing.
- datatables, pdfjs, revealjs: included as-is under /usr/libexec/rstudio/resources
- jsbn, highlightjs, qunitjs: some parts of them included in other resources, such as HTML templates

Unbundled:
- qtsingleapplication, websocketpp, hunspell + dictionaries, rapidxml, synctex, jQuery

Other changes:
- Validate .desktop file
- Expose rstudio-server script in /usr/bin
- Mark NOTICE as license, clean up more files
- Rebase patches

Comment 6 Iñaki Ucar 2020-02-21 12:06:53 UTC
Sorry, this is not ok: I thought 'ln -sf' also replaced directories, but it doesn't. It needs some more work.

Comment 7 Jerry James 2020-02-21 23:24:08 UTC
That's okay.  You've made great progress.  Specific comments below.

(In reply to Iñaki Ucar from comment #4)
> This conflicts with the "minimum requirements" guideline. RStudio requires
> R-devel, which in turn already requires gcc, gcc-c++ and others. That's why
> the guidelines for R packages state that only the R build-dependency is
> needed. This is not an R package though. And I don't have any special
> preference about this. What do you think?

I don't feel strongly about this either way.  If R-devel already pulls in the compiler, then I'm okay with that.

> You're right. They provide the .aff and the .dic, but also some .dic_delta
> with additions. What if I symlink the first two and keep the delta? Not sure
> what happens if there are definitions in the delta that are already in the
> .dic (I suppose it may happen if there's a version mismatch).

Those dictionary files are different enough that I worry that symlinking will lead to trouble.  Maybe you should keep the bundled dictionaries and add the Provides: bundled(whatever-needs-to-go-here).

> > - rapidxml-devel: src/cpp/core/include/core/rapidxml
> 
> This is just a header-only library, same version, and doesn't require any
> .so afterwards. I can substitute the file with a symlink. Is it worthwhile?

The reason for symlinking is so that, if the Fedora rapidxml package is patched to fix some bug, rstudio will get the patch.  You're right that if Fedora is shipping the straight unpatched upstream version, then there is nothing to be gained.

> > - zlib: src/cpp/core/zlib and src/cpp/core/include/core/zlib
> 
> I think we are fine here, because the one provided by the system should be
> picked. In fact, libz.so is listed in the automatic requires and no other
> libz.so is produced. So if I didn't miss anything, no change should be
> required.

Yes, I agree.

Comment 8 Iñaki Ucar 2020-02-22 00:21:40 UTC
Spec URL: https://iucar.fedorapeople.org/pkgs/rstudio.spec
SRPM URL: https://iucar.fedorapeople.org/pkgs/rstudio-1.2.5033-6.fc31.src.rpm

koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=41760859

More work:
- We're building against the system's rapidxml and websocketpp (solved the symlink issue).
- RStudio relies on old synctex and hunspell APIs. I'll try to push upstream to update those interfaces, but for the time being, we need to bundle them.
- I'm testing a build with unbundled dictionaries and the spelling check works just fine, so let's keep the symlink to /usr/share/myspell. I've listed hunspell in Requires accordingly.

And hopefully that's all.

Comment 9 Jerry James 2020-02-24 23:13:25 UTC
Here's a full review.  There are still a few issues, mostly minor except for some bundled fonts.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- If your application is a C or C++ application you must list a
  BuildRequires against gcc, gcc-c++ or clang.
  Note: No gcc, gcc-c++ or clang found in BuildRequires
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/C_and_C++/

  That's the same warning fedora-review generated last time.  This time I
  actually went to the referenced URL and read it.  I know I said I didn't
  care, but the policy is quite clear.  The BuildRequires is required.  The
  wording of the policy leaves no wiggle room, so far as I can see.

- Please consider changing the Source0 URL to this, so that the tarball contains
  the package name: %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

- Please add %{?_isa} to the Requires on the main package in the subpackages:
  Requires: %{name}%{?_isa} = %{version}-%{release}.  See
  https://docs.fedoraproject.org/en-US/packaging-guidelines/#_requiring_base_package

- The -desktop subpackage should Requires: hicolor-icon-theme, which owns the
  directories the icons are installed into.

- The -desktop subpackage should also Requires: shared-mime-info, which owns
  /usr/share/mime/packages.

- The -server subpackage contains a file marked %config but not
  %config(noreplace).  Please either add the noreplace, or add a comment stating
  why it is inappropriate.

- The main package has bundled fonts in these directories:
  /usr/libexec/rstudio/resources/presentation/revealjs.bundled/fonts
  /usr/libexec/rstudio/www/fonts

  The Lato fonts are available in the lato-fonts package.  The others do not
  seem to be available from Fedora.  See
  https://docs.fedoraproject.org/en-US/packaging-guidelines/FontsPolicy/
  for how they should be handled.

- One of the SHOULD items is "Patches link to upstream bugs/comments/lists or
  are otherwise justified."  Please consider doing so.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU Affero General Public License",
     "AGPL", "*No copyright* GNU General Public License (v2)", "*No
     copyright* AGPL", "zlib/libpng license", "BSD 3-clause "New" or
     "Revised" License", "BSD 3-clause "New" or "Revised" License GNU
     Affero General Public License", "*No copyright* Apache License
     (v2.0)", "Apache License (v2.0)", "Expat License", "ISC License",
     "Mozilla Public License (v1.1 or later) GNU General Public License (v2
     or later)", "Mozilla Public License (v1.1) GNU General Public License
     (v2 or later) or GNU Lesser General Public License (v2.1 or later)",
     "BSD 2-clause "Simplified" License", "Mozilla Public License GNU
     Lesser General Public License (v2.1)", "Apache License". 9273 files
     have unknown license.
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/systemd/system,
     /usr/share/icons/hicolor/32x32/mimetypes,
     /usr/share/icons/hicolor/32x32, /usr/share/icons/hicolor/256x256/apps,
     /usr/share/icons/hicolor/24x24/mimetypes,
     /usr/share/icons/hicolor/48x48, /usr/share/icons/hicolor/32x32/apps,
     /usr/share/icons/hicolor/256x256/mimetypes, /usr/share/icons/hicolor,
     /usr/share/icons/hicolor/48x48/mimetypes,
     /usr/share/icons/hicolor/16x16, /usr/share/icons/hicolor/24x24,
     /usr/share/icons/hicolor/16x16/mimetypes,
     /usr/share/icons/hicolor/24x24/apps, /usr/share/mime,
     /usr/share/icons/hicolor/48x48/apps, /usr/share/icons/hicolor/256x256,
     /usr/lib/systemd, /usr/share/mime/packages,
     /usr/share/icons/hicolor/16x16/apps
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: %config files are marked noreplace or the reason is justified.
     Note: No (noreplace) in %config /etc/pam.d/rstudio
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: systemd_post is invoked in %post, systemd_preun in %preun, and
     systemd_postun in %postun for Systemd service files.
     Note: Systemd service file(s) in rstudio-server
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rstudio-
     desktop , rstudio-server
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rstudio-1.2.5033-6.fc33.x86_64.rpm
          rstudio-desktop-1.2.5033-6.fc33.x86_64.rpm
          rstudio-server-1.2.5033-6.fc33.x86_64.rpm
          rstudio-debuginfo-1.2.5033-6.fc33.x86_64.rpm
          rstudio-debugsource-1.2.5033-6.fc33.x86_64.rpm
          rstudio-1.2.5033-6.fc33.src.rpm
rstudio.x86_64: W: name-repeated-in-summary C RStudio
rstudio.x86_64: W: spelling-error %description -l en_US workspace -> work space, work-space, works pace
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/bin/pandoc/pandoc /usr/bin/pandoc
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/bin/pandoc/pandoc-citeproc /usr/bin/pandoc-citeproc
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/resources/dictionaries /usr/share/myspell
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/resources/grid/datatables.bundled/js/jquery.js /usr/share/javascript/jquery/latest/jquery.js
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/resources/mathjax-26 /usr/share/javascript/mathjax
rstudio.x86_64: W: devel-file-in-non-devel-package /usr/libexec/rstudio/resources/templates/rcpp.cpp
rstudio-desktop.x86_64: W: spelling-error %description -l en_US workspace -> work space, work-space, works pace
rstudio-desktop.x86_64: W: no-documentation
rstudio-desktop.x86_64: W: dangling-symlink /usr/bin/rstudio /usr/libexec/rstudio/bin/rstudio
rstudio-desktop.x86_64: W: no-manual-page-for-binary rstudio
rstudio-desktop.x86_64: W: desktopfile-without-binary /usr/share/applications/rstudio.desktop rstudio
rstudio-server.x86_64: W: spelling-error %description -l en_US workspace -> work space, work-space, works pace
rstudio-server.x86_64: W: conffile-without-noreplace-flag /etc/pam.d/rstudio
rstudio-server.x86_64: W: no-documentation
rstudio-server.x86_64: W: dangling-symlink /usr/bin/rserver /usr/libexec/rstudio/bin/rserver
rstudio-server.x86_64: W: dangling-symlink /usr/bin/rserver-pam /usr/libexec/rstudio/bin/rserver-pam
rstudio-server.x86_64: W: dangling-symlink /usr/bin/rstudio-server /usr/libexec/rstudio/bin/rstudio-server
rstudio-server.x86_64: W: no-manual-page-for-binary rserver
rstudio-server.x86_64: W: no-manual-page-for-binary rserver-pam
rstudio-server.x86_64: W: no-manual-page-for-binary rstudio-server
rstudio.src: W: name-repeated-in-summary C RStudio
rstudio.src: W: spelling-error %description -l en_US workspace -> work space, work-space, works pace
6 packages and 0 specfiles checked; 0 errors, 24 warnings.




Rpmlint (debuginfo)
-------------------
Checking: rstudio-debuginfo-1.2.5033-6.fc33.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
rstudio-desktop.x86_64: W: spelling-error %description -l en_US workspace -> work space, work-space, works pace
rstudio-desktop.x86_64: W: no-documentation
rstudio-desktop.x86_64: W: dangling-symlink /usr/bin/rstudio /usr/libexec/rstudio/bin/rstudio
rstudio-desktop.x86_64: W: no-manual-page-for-binary rstudio
rstudio-server.x86_64: W: spelling-error %description -l en_US workspace -> work space, work-space, works pace
rstudio-server.x86_64: W: conffile-without-noreplace-flag /etc/pam.d/rstudio
rstudio-server.x86_64: W: no-documentation
rstudio-server.x86_64: W: dangling-symlink /usr/bin/rserver /usr/libexec/rstudio/bin/rserver
rstudio-server.x86_64: W: dangling-symlink /usr/bin/rserver-pam /usr/libexec/rstudio/bin/rserver-pam
rstudio-server.x86_64: W: dangling-symlink /usr/bin/rstudio-server /usr/libexec/rstudio/bin/rstudio-server
rstudio-server.x86_64: W: no-manual-page-for-binary rserver
rstudio-server.x86_64: W: no-manual-page-for-binary rserver-pam
rstudio-server.x86_64: W: no-manual-page-for-binary rstudio-server
rstudio.x86_64: W: name-repeated-in-summary C RStudio
rstudio.x86_64: W: spelling-error %description -l en_US workspace -> work space, work-space, works pace
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/bin/pandoc/pandoc /usr/bin/pandoc
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/bin/pandoc/pandoc-citeproc /usr/bin/pandoc-citeproc
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/resources/dictionaries /usr/share/myspell
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/resources/grid/datatables.bundled/js/jquery.js /usr/share/javascript/jquery/latest/jquery.js
rstudio.x86_64: W: dangling-symlink /usr/libexec/rstudio/resources/mathjax-26 /usr/share/javascript/mathjax
rstudio.x86_64: W: devel-file-in-non-devel-package /usr/libexec/rstudio/resources/templates/rcpp.cpp
5 packages and 0 specfiles checked; 0 errors, 21 warnings.



Source checksums
----------------
https://s3.amazonaws.com/rstudio-buildtools/gin-2.1.2.zip :
  CHECKSUM(SHA256) this package     : b98e704164f54be596779696a3fcd11be5785c9907a99ec535ff6e9525ad5f9a
  CHECKSUM(SHA256) upstream package : b98e704164f54be596779696a3fcd11be5785c9907a99ec535ff6e9525ad5f9a
https://s3.amazonaws.com/rstudio-buildtools/gwt-2.8.2.zip :
  CHECKSUM(SHA256) this package     : 970701dacc55170088f5eb327137cb4a7581ebb4734188dfcc2fad9941745d1b
  CHECKSUM(SHA256) upstream package : 970701dacc55170088f5eb327137cb4a7581ebb4734188dfcc2fad9941745d1b
https://github.com/rstudio/rstudio/archive/v1.2.5033.tar.gz :
  CHECKSUM(SHA256) this package     : ff5115bda56ee0fdee0ae2eb014ce5379774aeb3714a257a52da5b91a95e4408
  CHECKSUM(SHA256) upstream package : ff5115bda56ee0fdee0ae2eb014ce5379774aeb3714a257a52da5b91a95e4408


Requires
--------
rstudio (rpmlib, GLIBC filtered):
    /usr/bin/bash
    hunspell
    js-jquery
    ld-linux-x86-64.so.2()(64bit)
    libQt5Core.so.5()(64bit)
    libQt5Core.so.5(Qt_5)(64bit)
    libQt5Core.so.5(Qt_5.13)(64bit)
    libQt5DBus.so.5()(64bit)
    libQt5DBus.so.5(Qt_5)(64bit)
    libQt5Gui.so.5()(64bit)
    libQt5Gui.so.5(Qt_5)(64bit)
    libQt5Network.so.5()(64bit)
    libQt5Network.so.5(Qt_5)(64bit)
    libQt5PrintSupport.so.5()(64bit)
    libQt5PrintSupport.so.5(Qt_5)(64bit)
    libQt5Quick.so.5()(64bit)
    libQt5Quick.so.5(Qt_5)(64bit)
    libQt5Solutions_SingleApplication-2.6.so.1()(64bit)
    libQt5WebChannel.so.5()(64bit)
    libQt5WebChannel.so.5(Qt_5)(64bit)
    libQt5WebEngineCore.so.5()(64bit)
    libQt5WebEngineCore.so.5(Qt_5)(64bit)
    libQt5WebEngineWidgets.so.5()(64bit)
    libQt5WebEngineWidgets.so.5(Qt_5)(64bit)
    libQt5Widgets.so.5()(64bit)
    libQt5Widgets.so.5(Qt_5)(64bit)
    libR.so()(64bit)
    libboost_date_time.so.1.69.0()(64bit)
    libboost_filesystem.so.1.69.0()(64bit)
    libboost_iostreams.so.1.69.0()(64bit)
    libboost_program_options.so.1.69.0()(64bit)
    libboost_regex.so.1.69.0()(64bit)
    libboost_thread.so.1.69.0()(64bit)
    libc.so.6()(64bit)
    libcrypto.so.1.1()(64bit)
    libcrypto.so.1.1(OPENSSL_1_1_0)(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpam.so.0()(64bit)
    libpam.so.0(LIBPAM_1.0)(64bit)
    libpthread.so.0()(64bit)
    libssl.so.1.1()(64bit)
    libssl.so.1.1(OPENSSL_1_1_0)(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.1)(64bit)
    libstdc++.so.6(CXXABI_1.3.2)(64bit)
    libstdc++.so.6(CXXABI_1.3.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.5)(64bit)
    libstdc++.so.6(CXXABI_1.3.8)(64bit)
    libutil.so.1()(64bit)
    libuuid.so.1()(64bit)
    libuuid.so.1(UUID_1.0)(64bit)
    libz.so.1()(64bit)
    mathjax
    pandoc
    pandoc-citeproc
    rtld(GNU_HASH)
    shadow-utils
    systemd

rstudio-desktop (rpmlib, GLIBC filtered):
    rstudio

rstudio-server (rpmlib, GLIBC filtered):
    /bin/sh
    config(rstudio-server)
    pam
    rstudio

rstudio-debuginfo (rpmlib, GLIBC filtered):

rstudio-debugsource (rpmlib, GLIBC filtered):



Provides
--------
rstudio:
    bundled(aopalliance)
    bundled(gin)
    bundled(guice)
    bundled(gwt)
    bundled(gwt-websockets)
    bundled(hunspell)
    bundled(js-bn)
    bundled(js-datatables)
    bundled(js-highlight)
    bundled(js-pdf)
    bundled(js-qunit)
    bundled(js-reveal)
    bundled(js-xterm)
    bundled(json-spirit)
    bundled(sundown)
    bundled(synctex)
    rstudio
    rstudio(x86-64)

rstudio-desktop:
    application()
    application(rstudio.desktop)
    mimehandler(application/x-r-data)
    mimehandler(application/x-r-project)
    mimehandler(text/css)
    mimehandler(text/html)
    mimehandler(text/javascript)
    mimehandler(text/x-R)
    mimehandler(text/x-c++hdr)
    mimehandler(text/x-c++src)
    mimehandler(text/x-chdr)
    mimehandler(text/x-csrc)
    mimehandler(text/x-markdown)
    mimehandler(text/x-r)
    mimehandler(text/x-r-doc)
    mimehandler(text/x-r-history)
    mimehandler(text/x-r-html)
    mimehandler(text/x-r-markdown)
    mimehandler(text/x-r-presentation)
    mimehandler(text/x-r-profile)
    mimehandler(text/x-r-source)
    mimehandler(text/x-r-sweave)
    mimehandler(text/x-tex)
    rstudio-desktop
    rstudio-desktop(x86-64)

rstudio-server:
    config(rstudio-server)
    rstudio-server
    rstudio-server(x86-64)

rstudio-debuginfo:
    debuginfo(build-id)
    rstudio-debuginfo
    rstudio-debuginfo(x86-64)

rstudio-debugsource:
    rstudio-debugsource
    rstudio-debugsource(x86-64)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review -b 1803528 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: C/C++, Shell-api, Generic
Disabled plugins: Python, R, PHP, Perl, fonts, SugarActivity, Haskell, Ocaml, Java, Ruby
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 10 Iñaki Ucar 2020-02-25 12:12:49 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/iucar/rstudio/fedora-31-x86_64/01251826-rstudio/rstudio.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/iucar/rstudio/fedora-31-x86_64/01251826-rstudio/rstudio-1.2.5033-8.fc31.src.rpm

Changes implemented:
- Explicitly list gcc-c++ and java-devel as BuildRequires
- Change Source0 URL to include the package name
- Add isa flag to subpackages
- Require hicolor-icon-theme and shared-mimo-info in -desktop
- Mark config file as noreplace in -server
- Add comments to justify patches
- Unbundle Lato font
- Some refactoring

Additionally, I've downgraded gwt to v2.8.1. For some reason, the original OpenSUSE packaging changed the version to 2.8.2, but this RStudio version is not prepared for that. I tested the package during the weekend and it was constantly crashing when working with notebooks. This downgrade solves the issue.

Two things left:
- I can package the NewsCycle font for Fedora and unbunle it here. Then I need to set that review request as blocking for this one, right?
- Under /usr/libexec/rstudio/www/fonts, however, there is no standard font files. There is a very small .woff file that contains just 8 free icons from icomoon.io, and they are re-distributed under the same license as RStudio. I don't think it makes sense to unbundle this.

Comment 11 Iñaki Ucar 2020-02-25 21:57:39 UTC
Here's the newscycle-fonts package review request: https://bugzilla.redhat.com/show_bug.cgi?id=1807239

Comment 12 Kevin Kofler 2020-02-26 10:27:08 UTC
FYI, since this depends on qt5-qtwebengine, you can find dictionaries in Chromium format on the target system in the:
/usr/share/qt5/qtwebengine_dictionaries
directory. They are automatically converted from installed system-wide Hunspell dictionaries by a file trigger (written by me) in qt5-qtwebengine:
https://src.fedoraproject.org/rpms/qt5-qtwebengine/blob/master/f/qt5-qtwebengine.spec#_499
If you install an additional hunspell-* package, the file trigger will immediately convert it. (That's the big advantage of a file trigger over a regular %post scriptlet.)

So it is possible to avoid bundling those outdated bdic files.

Comment 13 Iñaki Ucar 2020-02-26 10:36:32 UTC
(In reply to Kevin Kofler from comment #12)
> FYI, since this depends on qt5-qtwebengine, you can find dictionaries in
> Chromium format on the target system in the:
> /usr/share/qt5/qtwebengine_dictionaries
> directory. They are automatically converted from installed system-wide
> Hunspell dictionaries by a file trigger (written by me) in qt5-qtwebengine:
> https://src.fedoraproject.org/rpms/qt5-qtwebengine/blob/master/f/qt5-
> qtwebengine.spec#_499
> If you install an additional hunspell-* package, the file trigger will
> immediately convert it. (That's the big advantage of a file trigger over a
> regular %post scriptlet.)
> 
> So it is possible to avoid bundling those outdated bdic files.

The dictionaries are unbundled already. I'm just pointing to /usr/share/myspell because there were no .bdic files, just .dic and .aff.

Comment 14 Iñaki Ucar 2020-02-27 00:43:30 UTC
Spec URL: https://iucar.fedorapeople.org/pkgs/rstudio.spec
SRPM URL: https://iucar.fedorapeople.org/pkgs/rstudio-1.2.5033-9.fc31.src.rpm

koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=41953151

The NewsCycle font has been approved and pushed to stable in rawhide. Font unbundling done here.

Comment 15 Jerry James 2020-03-02 23:08:01 UTC
Sorry to go silent on you.  I got bombarded last week.  I'm looking over the latest results from fedora-review and everything looks good to me.  This package is APPROVED.

Comment 16 Iñaki Ucar 2020-03-03 08:29:28 UTC
Thanks for a thorough review, I've learnt a lot!

Comment 17 Fedora Update System 2020-03-04 21:24:16 UTC
FEDORA-2020-24812a08fd has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-24812a08fd

Comment 18 Fedora Update System 2020-03-05 19:36:18 UTC
rstudio-1.2.5033-10.fc32 has been pushed to the Fedora 32 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-24812a08fd

Comment 19 Fedora Update System 2020-03-06 03:39:02 UTC
rstudio-1.2.5033-10.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-65ff671dba

Comment 20 Fedora Update System 2020-03-12 21:57:01 UTC
rstudio-1.2.5033-10.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2020-03-16 20:22:42 UTC
rstudio-1.2.5033-10.fc32 has been pushed to the Fedora 32 stable repository. If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2020-03-16 20:33:35 UTC
rstudio-1.2.5033-10.fc32 has been pushed to the Fedora 32 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.